ReadOnlyListPropertyBase (JavaFX 28)
Description: declaration: module: javafx.base, package: javafx.beans.property, class: ReadOnlyListPropertyBase

# Class ReadOnlyListPropertyBase<E>

java.lang.Object
javafx.beans.binding.ListExpression<E>
javafx.beans.property.ReadOnlyListProperty<E>
javafx.beans.property.ReadOnlyListPropertyBase<E>

Type Parameters:
  `E` - the list element type

All Implemented Interfaces:
  `Iterable<E>, Collection<E>, List<E>, SequencedCollection<E>, Observable, ReadOnlyProperty<ObservableList<E>>, ObservableListValue<E>, ObservableObjectValue<ObservableList<E>>, ObservableValue<ObservableList<E>>, ObservableList<E>`

public abstract class ReadOnlyListPropertyBase<E> extends ReadOnlyListProperty<E>
Base class for all readonly properties wrapping an `ObservableList`. This class provides a default implementation to attach listener.

Since:
  JavaFX 2.1
See Also:
  - `ReadOnlyListProperty`

- ## Property Summary

  ### Properties declared in class ListExpression

  `empty, size`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ReadOnlyListPropertyBase()`
  Creates a default `ReadOnlyListPropertyBase`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListener(InvalidationListener listener)`
  Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
  `void`
  `addListener(ChangeListener<? super ObservableList<E>> listener)`
  Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
  `void`
  `addListener(ListChangeListener<? super E> listener)`
  Add a listener to this observable list.
  `protected void`
  `fireValueChangedEvent()`
  This method needs to be called if the reference to the `ObservableList` changes.
  `protected void`
  `fireValueChangedEvent(ListChangeListener.Change<? extends E> change)`
  This method needs to be called if the content of the referenced `ObservableList` changes.
  `void`
  `removeListener(InvalidationListener listener)`
  Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
  `void`
  `removeListener(ChangeListener<? super ObservableList<E>> listener)`
  Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
  `void`
  `removeListener(ListChangeListener<? super E> listener)`
  Tries to remove a listener from this observable list.

  ### Methods declared in class ReadOnlyListProperty

  `bindContent, bindContentBidirectional, equals, hashCode, toString, unbindContent, unbindContentBidirectional`

  ### Methods declared in class ListExpression

  `add, add, addAll, addAll, addAll, asString, clear, contains, containsAll, emptyProperty, get, getSize, getValue, indexOf, isEmpty, isEqualTo, isNotEqualTo, isNotNull, isNull, iterator, lastIndexOf, listExpression, listIterator, listIterator, remove, remove, remove, removeAll, removeAll, retainAll, retainAll, set, setAll, setAll, size, sizeProperty, subList, toArray, toArray, valueAt, valueAt`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface Collection

  `parallelStream, removeIf, stream, toArray`

  ### Methods declared in interface Iterable

  `forEach`

  ### Methods declared in interface List

  `addFirst, addLast, getFirst, getLast, removeFirst, removeLast, replaceAll, reversed, sort, spliterator`

  ### Methods declared in interface Observable

  `subscribe`

  ### Methods declared in interface ObservableList

  `filtered, replaceRange, sorted, sorted`

  ### Methods declared in interface ObservableObjectValue

  `get`

  ### Methods declared in interface ObservableValue

  `flatMap, getValue, map, orElse, subscribe, subscribe, when`

  ### Methods declared in interface ReadOnlyProperty

  `getBean, getName`

- ## Constructor Details

  - ### ReadOnlyListPropertyBase

    public ReadOnlyListPropertyBase()
    Creates a default `ReadOnlyListPropertyBase`.

- ## Method Details

  - ### addListener

    public void addListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

    The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `Observable.removeListener(InvalidationListener)`

  - ### removeListener

    public void removeListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `Observable.addListener(InvalidationListener)`

  - ### addListener

    public void addListener(ChangeListener<? super ObservableList<E>> listener)
    Description copied from interface: `ObservableValue`
    Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

    The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `ObservableValue.removeListener(ChangeListener)`

  - ### removeListener

    public void removeListener(ChangeListener<? super ObservableList<E>> listener)
    Description copied from interface: `ObservableValue`
    Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `ObservableValue.addListener(ChangeListener)`

  - ### addListener

    public void addListener(ListChangeListener<? super E> listener)
    Description copied from interface: `ObservableList`
    Add a listener to this observable list.
    Parameters:
      `listener` - the listener for listening to the list changes

  - ### removeListener

    public void removeListener(ListChangeListener<? super E> listener)
    Description copied from interface: `ObservableList`
    Tries to remove a listener from this observable list. If the listener is not attached to this list, nothing happens.
    Parameters:
      `listener` - a listener to remove

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent()
    This method needs to be called if the reference to the `ObservableList` changes. It sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `ListChangeListener`. This method needs to be called, if the value of this property changes.

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent(ListChangeListener.Change<? extends E> change)
    This method needs to be called if the content of the referenced `ObservableList` changes. Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `ListChangeListener`. This method is called when the content of the list changes.
    Parameters:
      `change` - the change that needs to be propagated